<template>
  <main>
    <preloader v-if="isLoad"></preloader>
    <template
      v-for="content in pageContent"
      :key="content.index"
    >
      <!-- баннеры -->
      <div
        v-if="content.type === 'banners'"
        class="main-banners"
      >
        <MainBanner :content="content.items[0]" />
        <template
          v-for="(item, index) in content.items.slice(1)"
          :key="item.id"
        >
          <router-link
            v-if="item.icon === 'arrow'"
            class="main-banners-item"
            :class="'main-banners-item' + (index + 2)"
            :to="item.link.href"
            :title="item.link.title"
          >
            <MainBannerSmall :item="item" />
          </router-link>
          <a
            v-else
            v-smooth-scroll="{ duration: 1000, offset: -50 }"
            class="main-banners-item"
            :class="'main-banners-item' + (index + 2)"
            :href="item.link.href"
            :title="item.link.title"
          >
            <MainBannerSmall :item="item" />
          </a>
        </template>
      </div>

      <!-- партнеры -->
      <div
        v-if="content.type === 'text_slider'"
        class="partners-wrapp"
      >
        <div
          class="partner-text"
          v-html="content.text"
        ></div>
        <PartnersGallery
          :images="content.items"
          :loop="false"
        />
        <!-- <slider-images :images="content.items" :loop="false"/> -->
      </div>

      <!-- ассортимент кормов -->
      <SliderBlockWhite
        v-if="content.type === 'products'"
        :title="content.title"
        :posttitle="content.subtitle"
        :loop="false"
        :fish-types="true"
        :gap="30"
        id-slider="assort-main"
      >
        <template #fishTypes v-if="content.sections">
          <div
            class="type-button-wrapper"
          >
            <Button
              v-for="btn in content.sections"
              :key="btn.id"
              :class="{ active: currentType.code === btn.code }"
              @click="selectType(btn)"
              class="splide__slide"
            >
              <slot>{{ btn.name }}</slot>
            </Button>
          </div>
        </template>
        <template
          #slide
          v-if="content.sections[0]"
        >
          <div
            v-for="feed in assortmentsItem.items"
            :key="feed.id"
            class="block-item feed-block splide__slide"
          >
            <FeedItem
              v-if="feed"
              :content="feed"
              :btn="content.sections[0].items"
              :codeRouter="currentType.code"
            />
          </div>
        </template>
      </SliderBlockWhite>

      <!-- Сотрудничество с ВНИРО -->
      <vniro-block
        :id="vniroId"
        :content="content"
        v-if="content.type === 'schild'"
      />

      <!-- Комплекс лабораторных исследований -->
      <SliderBlockWhite
        v-if="content.type === 'slider_text_elements'"
        id="lab"
        :title="content.title"
        :posttitle="content.subtitle"
        :loop="false"
      >
        <template #slide>
          <div
            v-for="(step, index) in content.items"
            :key="index"
            class="block-item lab-block splide__slide"
          >
            <div class="lab-content">
              <div class="lab-number">{{ '0' + (index + 1) }}</div>
              <div
                class="lab-anons"
                v-html="step"
              ></div>
            </div>
          </div>
        </template>
      </SliderBlockWhite>

      <!-- Калькулятор кормления -->
      <div
        id="calc"
        v-if="false"
      >
        <!-- <h2 class="calc-title">Калькулятор кормления</h2>
        <div class="calc-step-wrapp">
          <div class="calc-step-block">
            <div class="calc-step-title">Шаг 1</div>
            <div class="calc-step">
              <h4>Выберите вид рыбы</h4>
              <div class="type-button-wrapper">
                <Button v-for="btn in fishTypesArr" :key="btn.index">
                  <slot>{{ btn }}</slot>
                </Button>
              </div>
            </div>
          </div>
          <div class="calc-step-block">
            <div class="calc-step-title">Шаг 2</div>
            <div class="calc-step">
              <h4>Срок</h4>
            </div>
          </div>
          <div class="calc-step-block calc-step-age">
            <div class="calc-step-title">Шаг 3</div>
            <div class="calc-step">
              <div class="calc-age">
                <h4>Возраст</h4>
                <span>{{ selectAge }} месяца</span>
              </div>
              <RangeInput @selectAge="getCalcAge"></RangeInput>
            </div>
          </div>
          <div class="calc-step-block">
            <Button color="blue" />
          </div>
        </div>
        <VTable
          posttitle="На 100 кг рыбы в сутки"
          title="Рекомендуемые нормы кормления"
          :btnPostTable="true"
        ></VTable> -->
      </div>
      <div
        :id="formsId"
        v-if="content.type === 'form'"
      >
        <v-form :content="content" :messages="messages" :page_url="$route.path"/>
      </div>

      <!--News  -->
      <div
        id="news-main"
        v-if="content.type === 'news'"
      >
        <div class="news-main-header">
          <h2>{{ content.title }}</h2>
          <router-link
            v-if="content.btn"
            :to="content.btn.link.href"
          >
            <Button color="blue">
              <slot>{{ content.btn.name }}</slot>
            </Button>
          </router-link>
        </div>
        <div class="news-main-wrapper">
          <div
            v-for="(item, index) in content.items"
            :key="index"
            class="news-main-block"
          >
            <NewsItem
              :img="item.previewImage"
              :link="item.code"
              :text="item.text"
              :title="item.name"
              :date="item.publication_data"
              :btn="content.link_text_detail_page"
            />
          </div>
        </div>
        <div class="news-main-mob">
          <NewsMainMob :id-slider="newsMainMob" :pagination="true">
            <template #slide>
              <div
                v-for="(item, index) in content.items"
                :key="index"
                class="news-main-block splide__slide"
              >
                <NewsItem
                  :img="item.previewImage"
                  :link="item.code"
                  :text="item.text"
                  :title="item.name"
                  :date="item.publication_data"
                  :btn="content.link_text_detail_page"
                />
              </div>
            </template>
          </NewsMainMob>
        </div>
      </div>

      <!-- Contacts -->
      <div
        id="contacts-main"
        v-if="content.type === 'contacts'"
      >
        <Contacts :content="content" />
      </div>
    </template>
  </main>
</template>

<script>
import { HTTP, Routes } from '../api/API';

import Contacts from '../components/Contacts.vue';
import FeedItem from '../components/FeedItem.vue';
import SliderBlock from '../components/SliderBlock.vue';
import VTable from '../components/Table.vue';
import Button from '../components/common/button.vue';
import RangeInput from '../components/common/range-input.vue';
import ArrowRight from '../components/icons/arrow-right.vue';
import Arrow45 from '../components/icons/arrow45.vue';
import NewsItem from '../components/NewsItem.vue';
import VniroBlock from '../components/VniroBlock.vue';
import MainBanner from '../components/MainBanner.vue';
import MainBannerSmall from '../components/MainBannerSmall.vue';
import SliderImages from '../components/SliderImages.vue';
import PartnersGallery from '../components/PartnersGallery.vue';
import SliderBlockWhite from '../components/SliderBlockWhite.vue';
import VForm from '../components/VForm.vue';
import ArrowMore from '../components/icons/arrow-more.vue';
import NewsMainMob from '../components/NewsMainMob.vue';
import Preloader from '../components/common/preloader.vue';


export default {
  components: {
    SliderBlock,
    Button,
    Arrow45,
    ArrowRight,
    VTable,
    Contacts,
    RangeInput,
    FeedItem,
    NewsItem,
    VniroBlock,
    MainBanner,
    MainBannerSmall,
    SliderImages,
    PartnersGallery,
    SliderBlockWhite,
    VForm,
    ArrowMore,
    NewsMainMob,
    Preloader,
  },
  props: {},
  data() {
    return {
      // selectAge: "",
      banners: [],
      partners: [],
      partnersBlock: {},
      contacts: null,
      bannersBlock: {},
      partnersBlockTitle: '',
      vniroBlock: {},
      vniroId: {},
      laboratoryTests: {},
      news: {},
      mainBanner: {},
      newsBtn: {},
      assortments: null,
      assortmentsItem: null,
      currentType: null,
      form: null,
      pageContent: [],
      messages: [],
      millis: 0,
      isLoad: true
    };
  },
  computed: {
    toAllNews() {
      return this.newsBtn && this.newsBtn.link && this.newsBtn.link.href;
    },
  },
  created() {},
  mounted() {
    this.getContent();
  },
  updated() {},
  methods: {
    // getCalcAge(value) {
    //   console.log("value: ", value);
    //   this.selectAge = value;
    // },
    selectType(el) {
      this.currentType = el;
      this.getAssortment(el.code);
    },
    getContent() {
      let start = Date.now();
      HTTP.get(Routes.homePage)
        .then(response => {
          // console.log('response.data.home: ', response.data.data.content);
          this.messages = response.data.data.messages;
          this.pageContent = response.data.data.content;
          const home = response.data.data.content;
          home.forEach(item => {
            switch (item.type) {
              case 'products': // блок ассортимент кормов
                this.assortmentsItem = item.sections[0].items;
                this.currentType = this.assortmentsItem; // записываем первый элемент в выбранные
                break;
              default:
                break;
            }
            //записываем якоря
            switch (item.type) {
              case 'anchor':
                if (item.code === 'vniro') {
                  this.vniroId = item.code;
                } else if (item.code === 'forms') {
                  this.formsId = item.code;
                } else if (item.code === 'top') {
                  this.toTop = item.code;
                }
                break;
              default:
                break;
            }
          });
        })
        .catch(error => {
          console.log(error);
        })
        .finally(() => {
          this.millis = Date.now() - start;
          // console.log('this.millis: ', this.millis);
          this.isLoad = false
        });
    },
    getAssortment(code) {
      HTTP.get(`${Routes.productItems}&section=${code}`)
        .then(response => {
          this.assortmentsItem = response.data.data.section;
        })
        .catch(error => {
          console.log(error);
        });
    },
  },
};
</script>
